<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>06 OSI Layer 4</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Transport Layer</h1>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					
						<section>
							<h2>Objectives</h2>
							<a href="../objectives.html" target="_blank">OSI Layer 4 Objectives</a>
						</section>
	
						<section>
							<h2>Layer 4</h2>
							<p>This layer handles quality of service, reliability, flow control, and error correction</p>
							<ul>
								<li>TCP: reliable connection</li>	
								<li>UDP: Not connection oriented</li>
								<li>Provides Data Transfer</li>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
						</aside>
						</section>
					
			
                    <section>
                        <h2>TCP</h2>
						<p>The TCP protocol is connection oriented</p>
						<ul>
							<li>Reliable:</li>	
							<li>Ordered: The messages are delivered in a particular order</li>
							<li>Datagrams: </li>
							<li>Heavyweight</li>
							<li>called SYN, SYN-ACK, and ACK</li>
						
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
					</section>
					<section>
						<h3>TCP FLAGS</h3>
						<ul>
							<li>SYN - first step in establishing a three way handshake between two hosts</li>
							<li>ACK - used to acknowledge the successful receipt of a packet</li>
							<li>FIN - The finished flag means there is no more data from the sender.</li>
							<li>URG - used to notify the receiver to process the urgent packets before processing all other packets.</li>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h3>TCP FLAGS</h3>
						<ul>
							<li>RST - The reset flag: a packet is sent to a particular host that was not expecting it.</li>
							<li>PSH - The push flag : tells the receiver to process these packets as they are received instead of buffering them.</li>
					
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h2>TCP 3-way handshake</h2>
							<ul>
								<li><a href="https://www.guru99.com/tcp-3-way-handshake.html">TCP 3-Way Handshake (SYN, SYN-ACK,ACK)</a></li>
							</ul>
							<aside class="notes">
								Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
							</aside>
					</section>
                    <section>
						<h2>UDP</h2>
						<p>UDP is a non-connection oriented protocol</p>
						<ul>
							<li>Unreliable: In UDP, there is no concept of packet retransmission</li>	
							<li>Not ordered: The order in which packages are sent and received cannot be determined</li>
							<li>Lightweight and speed</li>
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
					</section>
					<section>
						<h3>What is UDP?</h3>
						<a href='https://www.educative.io/edpresso/what-is-udp#:~:text=Main%20features,as%20a%20connection%2Dless%20protocol.'>Main Features</a>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
				<section>
					<h2>Requests</h2>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h3>Python Modules</h3>
					<ul>
						<li>httplib2: This is a comprehensive HTTP client library.It supports features like caching, keep-alive, compression, redirects and many kinds of authentication.</li>
						<li>urllib2: This is an extensively used module for fetching HTTP URLs in a complex world.</li>
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>

				</section>
                <section>
					<h3>Python Modules</h3>
					<ul>
						
						<li>Requests: This is an Apache2 licensed HTTP library which is written in Python, gifted with many capabilities to result in productivity.</li>
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>   
				<section>
					<h3>Requests</h3>
					<p>Requests allow you to send requests to an HTTP server and get responses and messages sent by the server</p>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section> 
				<section>
					<h3>request.get()</h3>
					<p>The request.get() function sends a request using the get method with the following syntax:</p>
						<pre>
					<code data-trim data-noescape>
						
						>>> import requests
						>>> response = requests.get('http://www.github.com')
					</code>
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
				</section>
				<section>
					<h3>Example Properties of response object</h3>
					<pre>
					<code data-trim data-noescape>
						
						>>> response.status_code
						200
						>>> response.reason
						'OK'
						>>> response.url
						'http://www.github.com/'
						>>> response.headers['content-type']
						'text/html; charset=utf-8'
					</code>
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
				</section>
				<section>
					<p>Python’s requests module provides in-built method called get() for making a GET request to a specified URI</p>
					<pre>
					<code data-trim data-noescape>
						
						import requests 
   
						# Making a GET request 
						r = requests.get('https://api.github.com/users/cybertrainingusaf') 
						  
						# check status code for response received 
						# success code - 200 
						print(r) 
						  
						# print content of request 
						print(r.content) 
					</code>
						</pre>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
				</section>
                <section>
					<p>Working with JSON</p>
					<pre>
					<code data-trim data-noescape>
						>>> import requests
						>>> response = requests.post('http://httpbin.org/post', json={"key": "value"})
						>>> response.status_code
						200
						>>> response.json()
						{'args': {},
						'data': '{"key": "value"}',
						'files': {},
						'form': {},
					</code>
						</pre>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
						</aside>
				</section>
				<section>
					<h3>BeautifulSoup</h3>
					<p><a href='https://www.crummy.com/software/BeautifulSoup/bs4/doc/'>bs4 documentation</a></p>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<h3>BeautifulSoup</h3>
					<p>a lightweight Python library, to extract and navigate HTML content easily and forget overly complex regular expressions and text parsing</p>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
						<p>Intention</p>
						<ul>
							<li>This tool is not intended directly for web scraping</li>
							<li>the purpose of this tool is to provide an interface that allows access in a very simple way to the content of a web page.</li>
						</ul>
						<aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
				<section>
					<h3>Requests and BS4 Demo Labs</h3>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<p>Performance Labs</p>
					<ul>
						<li>Write a Python program to download and display the content of an rfc2616.txt for https://www.w3.org/Protocols/.</li>
						<li>Write a Python script to extract and display all the header tags from https://www.howtogeek.com/</li>
						<li>Write a Python script to extract and display all the image links from https://en.wikipedia.org/wiki/George_S._Patton. </li>
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>

			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>		
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
